/*window.onload = function() {
    var dashboard = document.querySelector(".devices-dashboard");
    dashboard.classList.add('loaded');
};*/

// =============================================================================================== rotating cogwheels

{
    "use strict";


    // utils
    // ===============================================================================================

    const pipe = (...functions) => arg => functions.reduce((a, b) => b(a), arg);

    const define = (object, property, value) =>
    Object.defineProperty(object, property, {
        value,
        writable: true,
        configurable: true,
        enumerable: true
    });

    const first = list => list[0];

    const last = list => list[list.length - 1];

    const getRandomInt = (min, max) =>
    Math.floor(Math.random() * (max - min)) + min;

    const interval = (callback, delay) => {
    const tick = now => {
        if (now - start >= delay) {
            start = now;
            callback();
        }
        requestAnimationFrame(tick);
    };
    let start = performance.now();
    requestAnimationFrame(tick);
};


    // easing equations
    // ===============================================================================================

    const easeInQuart = (t, b, c, d) =>
    c * (t/=d) * Math.pow(t, 3) + b;

    const easeOutQuart = (t, b, c, d) =>
    -c * ((t=t/d-1) * Math.pow(t, 3) - 1) + b;

    const easeInOutQuart = (t, b, c, d) => {
    if ((t/=d/2) < 1) return c/2 * Math.pow(t, 4) + b;
    return -c/2 * ((t-=2) * Math.pow(t, 3) - 2) + b;
};

    const easeInOutBack = (t, b, c, d, s) => {
    if (s == undefined) s = 1.70158;
    if ((t/=d/2) < 1) return c/2*(t*t*(((s*=(1.525))+1)*t - s)) + b;
    return c/2*((t-=2)*t*(((s*=(1.525))+1)*t + s) + 2) + b;
};

    const easeOutElastic = (t, b, c, d, frequency = 700) => {
    if (t == 0 || c == 0) return b;
    if ((t /= d) == 1) return b + c;
    const a = c;
    const p = d * (1 - Math.min(frequency, 999) / 1000);
    const s = a < Math.abs(c) ? p / 4 : p / (2 * Math.PI) * Math.asin(c / a);
    return a * Math.pow(2, -10 * t) * Math.sin((t * d - s) * (2 * Math.PI) / p) + c + b;
};


    // rotating cogwheels
    // ===============================================================================================

    {
        const findRotationCenter = element =>
        ["x", "y"].reduce((coordinates, axis) => {
            const center = `c${axis}`;
        const separator = coordinates.length ? " " : "";
        return coordinates + separator + element.nextElementSibling.getAttribute(center);
    }, "");

        const cogwheels = Array.from(
                document.querySelectorAll(".investment-header .heading-icon path"), (element, index) => ({
                element,
                center: findRotationCenter(element),
                direction: index ? -1 : 1
            }));

        const duration = 15000;
        const turn = 360;
        const state = {};

        const rotate = now => {
        if (state.start == null) define(state, "start", now);
        define(state, "elapsed", now - state.start);
        define(state, "progress", state.elapsed / duration);

        const rotation = Math.min(turn * state.progress, turn);
        cogwheels.forEach(object =>
        object.element.setAttribute(
            "transform", `rotate(${rotation * object.direction} ${object.center})`));

        if (rotation == turn) delete state.start;
        requestAnimationFrame(rotate);
    };

        requestAnimationFrame(rotate);
    }

}

